//stock.h

#ifndef STOCK_H
#define STOCK_H

#include <vector>
using namespace std;

// BEGIN code1
class Path{
 public:
  vector<double> prices;
  vector<double> allJumps;
  vector<double> times;
  Path(vector<double> thePrices,vector<double> theJumps,  vector<double> times);
  Path subPath(  vector<double> subtimes );
  int timeIndex(double time);
};
// END code1

// BEGIN code2
class Stock{
 public:
  double St0;     //current price
  double r;       //interest
  double sigma;   //variarity

  //constructors
  Stock(double theSt0,double theR,double theSigma);
  Stock();

  Path simulatePath(vector<double> times);
  Path simulatePath(vector<double> times,int seed);
  vector<double> oneStepUnderlying1(int J_H,double currentPrice,double deltaT);
  vector<double> oneStepUnderlying2(int J_H,double currentPrice,double deltaT);
  vector<double> haarUnderlying(int J_H,vector<double> times);
  vector<double> rp(int J_H,double deltaT);
};
// END code2
#endif
  
