//haar.h

#ifndef HAAR_H
#define HAAR_H

#include <vector>
#include <cmath>
using namespace std;

// BEGIN code1
class Haar
{
 public:
  vector<double> haarItems;//The vector for haar operation that contain 2^J elements
  int j,J;

  Haar(vector<double> theItems,int the_J, int the_j);
  Haar();

  Haar haarAnalysis(int numberOfCalls);
  Haar haarSynthesis(int numberOfCalls);
  Haar thresholdCompression(double threshold, int &Rt);
  Haar RCompression(int R);
  Haar S0RCompression(int R);

  void printHaarVector();
  double energy();

 private:
  Haar oneStepHaarAnalysis();
  Haar oneStepHaarSynthesis();
};
// END code1

#endif
