//option.h
#ifndef OPTION_H
#define OPTION_H

#include "stock.h"

#include <cmath>
#include <iostream>
#include <vector>
using namespace std;

// BEGIN code1
class Option{
 public:
  Stock stock;
  double etime; //expiration time
  double P;     //expiration (strike) price
  double amount;
  
  Option(Stock theStock,double theTime,double strikePrice,double amount);
  Option();

  virtual double exactPrice() {};
  virtual double value(double stockPrice,double time) {};
  virtual double evalue(double stockPrice) {};
  virtual double get_phi(double d1) {};
  virtual vector<double> BSPortfolio(Path path) {};
  virtual vector<double> HHPayoff(int j_H,double stockPrice,
				  double time,double deltaT){};

  double get_d1(double stockPrice,double time);
  double get_d2(double d1,double time);
  vector<double> holdingPortfolio(Path path);
};
// END code1

// BEGIN code2
class EuCall:public Option{
 public:
  EuCall(Stock theStock,double theTime,double strikePrice,double amount);
  EuCall();

  double exactPrice();
  double value(double stockPrice,double time);
  double evalue(double stockPrice);
  double get_phi(double d1);
  vector<double> BSPortfolio(Path path);
  vector<double> HHPayoff(int j_H,double stockPrice,double time,double deltaT);
  vector<double> HHPayoff(int j_H,vector<double> times);
};
// END code2

// BEGIN code3
class EuPut:public Option{
 public:
  EuPut(Stock theStock,double theTime,double strikePrice,double amount);
  EuPut();
  double exactPrice();
  double value(double stockPrice,double time);
  double evalue(double stockPrice);
  double get_phi(double d1);
  vector<double> BSPortfolio(Path path);
  vector<double> HHPayoff(int j_H,double stockPrice,double time,double deltaT);
};
// END code3

#endif
