//transformTest.c

#include <cmath>
#include <iostream>
#include "haar.h"
#include "plotting.h"
#include "falgorithm.h"

// BEGIN code
int main(int argc, char **argv)
{
  vector<double> transformVector;

  transformVector.push_back(56);
  transformVector.push_back(40);
  transformVector.push_back(8);
  transformVector.push_back(24);
  transformVector.push_back(48);
  transformVector.push_back(48);
  transformVector.push_back(40);
  transformVector.push_back(16);

  Haar IV(transformVector,3,3);

  Haar OV1 = IV.haarAnalysis(3);
  
  int R=3,Rt=0;
  double threshold = 0.95;

  //Haar OV2 = OV1.RCompression(R);
  Haar OV2 = OV1.thresholdCompression(threshold,Rt);
  cout<<"Rt = "<<Rt<<endl;
  Haar OV3 = OV2.haarSynthesis(3);
  Haar OV4 = OV1.haarSynthesis(3);

  
  char *names[20];
  vector<double> xvector;
  vector< vector<double> > yvectors;

  for(int i=0; i<8;i++)
    xvector.push_back(i * 1.0);

  yvectors.push_back(IV.haarItems);
  yvectors.push_back(OV3.haarItems);
  yvectors.push_back(OV4.haarItems);

  names[0] = "Original";
  names[1] = "Compressed";
  names[2] = "Non-compressed";

  vectorPlotting(yvectors,xvector,names);
  return 0;
}
// END code
