//stockTest.c
#include "stock.h"
#include "falgorithm.h"
#include "plotting.h"

#include <iostream>
#include <cmath>
#include <vector>
using namespace std;
// BEGIN code
int main(int argc,char *argv[]){
  if(argc !=2){
    cout<<"stockTest 1(path)/2(underlying)/3(compare underlying algorithms)"<<endl;
    exit(1);
  }
  double St0=20.0,interest=0.2,sigma=0.2;
  Stock stock(St0, interest, sigma);

  vector<double> times;
  for(int i = 0; i<4;i++)
    times.push_back(i*0.1);


  char *names[20];
  vector<double> xvector;
  vector< vector<double> > yvectors;

  if(atoi(argv[1]) == 1){
    names[0] = "All jumps";
    names[1] = "All prices";
    Path path = stock.simulatePath(times);

    xvector = path.times;
    yvectors.push_back( path.allJumps ); 
    yvectors.push_back( path.prices );
  }
  else if(atoi(argv[1]) == 2){
    names[0] = "Haar underlying";
    vector<double> underlying = stock.haarUnderlying(4,times);

    for(int i=0; i<underlying.size();i++)
      xvector.push_back(i * 1.0);
    yvectors.push_back( underlying ); 
  }
  else{
    names[0] = "underlying v1";
    names[1] = "underlying v2";
    vector<double> underlying1 = stock.oneStepUnderlying1(10,St0,times[1]-times[0]);
    vector<double> underlying2 = stock.oneStepUnderlying2(10,St0,times[1]-times[0]);

    for(int i=0; i<underlying1.size();i++)
      xvector.push_back(i * 1.0);
    yvectors.push_back( underlying1 ); 
    yvectors.push_back( underlying2 );
  }

  vectorPlotting(yvectors,xvector,names);
  return 0;
}
// END code
