//bspTest.c
#include "option.h"
#include "stock.h"
#include "plotting.h"
#include "falgorithm.h"

#include <cmath>
#include <iostream>
#include <vector>
using namespace std;

int main(int argc, char **argv){
  double St0=21.0,interest=0.2,sigma=0.2;
  double time1=0.9,time2=0.9,strikePrice=20.0,amount=1.0; int optionType=1;
  vector<double> times;
  for(int i = 0; i<10;i++)
    times.push_back(i*0.1);

  Stock stock(St0, interest, sigma);
  EuCall ec(stock, time1, strikePrice, amount);
  EuPut ep(stock, time2, strikePrice, amount);  
  
  Path path = stock.simulatePath(times);


  cout<<"Times are:  ";
  for(int i =0; i<times.size();i++)
    cout<<times[i]<<"   ";
  cout<<endl;

  cout<<"Path is:  ";
  for(int i =0; i<path.prices.size();i++)
    cout<<path.prices[i]<<"   ";
  cout<<endl;

  int k=7,j_H=4;
  vector<double>  hhpayoff1= ec.HHPayoff(j_H,path.prices[k],path.times[k],path.times[k+1] - path.times[k]);

  vector<double> hhpayoff2 =  ep.HHPayoff(j_H,path.prices[k],path.times[k],path.times[k+1] - path.times[k]);

  char *names[20];
  names[0] = "Call HH Payoff";
  names[1] = "Put HH Payoff";

  vector<double> xvector = times;
  vector< vector<double> > yvectors;
  yvectors.push_back(hhpayoff1);
  yvectors.push_back(hhpayoff2);

  cout<<hhpayoff1.size()<<"   "<<hhpayoff2.size()<<endl;
  for(int i =0; i<hhpayoff1.size();i++)
    cout<<hhpayoff1[i]<<"   "<<hhpayoff2[i]<<"   "<<endl;

  vectorPlotting(yvectors,xvector,names);

  return 0;
}

